﻿namespace U2UConsult.Composite.Communication.Sample.AggregatedEvents
{
    using System.ComponentModel.Composition;
    using Microsoft.Practices.Prism.Events;

    /// <summary>
    /// Composite publisher.
    /// </summary>
    [Export(typeof(IPublisher))]
    public class Publisher: IPublisher
    {
        /// <summary>
        /// Prism Event Aggregator.
        /// </summary>
        private EventAggregator eventAggregator;
        
        /// <summary>
        /// Gets or sets Prism's event aggregator.
        /// </summary>
        [Import]
        public EventAggregator EventAggregator
        {
            get { return this.eventAggregator; }
            set { this.eventAggregator = value; }
        }

        /// <summary>
        /// Raise the publish event.
        /// </summary>
        public void Publish()
        {
            PublishedEvent pe = this.eventAggregator.GetEvent<PublishedEvent>();
            pe.Publish(null);
        }
    }
}
