﻿namespace U2UConsult.Composite.Communication.Sample.RegularEvents
{
    using System;
    using System.ComponentModel.Composition;

    /// <summary>
    /// Publisher using a regular event.
    /// </summary>
    [Export(typeof(IPublisher))]
    public class Publisher : IPublisher
    {
        /// <summary>
        /// Published event.
        /// </summary>
        public event EventHandler Published;

        /// <summary>
        /// Raise the publish event.
        /// </summary>
        public void Publish()
        {
            this.OnPublished(EventArgs.Empty);
        }

        /// <summary>
        /// MS guidelines compliant virtual protected event raiser.
        /// </summary>
        /// <param name="e">Event arguments.</param>
        protected virtual void OnPublished(EventArgs e)
        {
            if (this.Published != null)
            {
                this.Published(this, e);
            }
        }
    }
}
